import request from "../utils/request"

// -----------------------------CRM接口

// 获取合同种类列表
 /**
  * @param {
  * product_id - 产品: 1-FICC(默认); 2-权益 - 非必填
  * } data 
  * @returns 
  */
export function getPermissionList(data) {
  return request({
      url:'/crm/contract/permission_list',
      method:'get',
      params:data
  })
}
// 获取销售列表（包括禁用的销售） -- 已替换为 getSellerTeamList()
 /**
  * @param {
  * } data 
  * @returns 
  */
export function getSellerList() {
  return request({
      url:'/crm/company_seller/list',
      method:'get'
  })
}
// // 获取销售列表 - 无分组
//  /**
//   * @param {
//  * } data 
//  * @returns 
//  */
// export function getSellerListNoG() {
//  return request({
//      url:'/crm/company_seller/all_list',
//      method:'get'
//  })
// }
// 获取详细的销售列表（包含小组以及禁用的小组）
 /**
  * @param {
 * } data 
 * @returns 
 */
export function getSellerTeamList() {
 return request({
     url:'/crm/company_seller/team_list',
     method:'get'
 })
}
// 根据合同编号搜索合同列表
 /**
  * 
  * @param {
  * page_size - 每页数据量 - 必填
  * current - 页码 - 必填
  * keyword - 关键词 - 非必填
  * product_id - 产品: 0-全部(默认); 1-FICC; 2-权益 - 非必填
  * } data 
  * @returns 
  */
export function getContractSearchList(data) {
  return request({
      url:'/crm/contract/search_list',
      method:'get',
      params:data
  })
}

// 合同套餐及品种
 /**
  * 
  * @param {
 * contract_id - 合同ID - 必填
 * } data 
 * @returns 
 */
export function getServiceDetail(data) {
 return request({
     url:'/crm/contract/service_detail',
     method:'get',
     params:data
 })
}
 /**
  * 获取销售组别列表
  * @param {
 * seller_type - 1 ficc销售、2 权益销售 - 必填
 * } data 
 * @returns 
 */
 export function getSellerGroupList(data) {
  return request({
      url:'/crm/company_seller/group_list',
      method:'get',
      params:data
  })
 }
