import request from "../utils/request"

// -----------------------------部门
 // 获取部门列表
 /**
  * 
  * @param {
  * dept_name - 部门名称
  * page_size - 每页条数
  * current - 页数
  * } data 
  * @returns 
  */
export function getDepartmentList(data) {
  return request({
      url:'/system/dept/list',
      method:'get',
      params:data
  })
}
  // 新增部门
  /**
   * 
   * @param {
  * parent_id - 上级部门id
  * dept_name - 部门名称
  * sort - 排序
  * } data 
  * @returns 
  */
export function addDepartment(data) {
  return request({
      url:'/system/dept/add',
      method:'post',
      data
  })
}
// 编辑部门
  /**
   * 
   * @param {
   * parent_id - 上级部门id
   * dept_name - 部门名称
   * sort - 排序
   * } data 
   * @returns 
   */
export function editDepartment(data) {
  return request({
      url:'/system/dept/edit',
      method:'put',
      data
  })
}
// 删除部门
  /**
   * 
   * @param {
   * dept_id - 部门id
   * } data 
   * @returns 
   */
export function deleteDepartment(data) {
  return request({
      url:'/system/dept/delete',
      method:'delete',
      data
  })
}

// ------------------------------菜单
// 获取列表
export function getMenuList(data) {
  return request({
      url:'/system/menu/all_list',
      method:'get',
      params:data
  })
}

// 获取当前用户有权限的路由
export function getAsyncRoutes() {
  return request({
      url:'/system/menu/list',
      method:'get'
  })
}

// 获取当前用户有权限的按钮
export function getPermissionButtons(data) {
  return request({
      url:'/system/menu/buttons',
      method:'get',
      params:data
  })
}

// 添加菜单
export function addMenu(data) {
  return request({
      url:'/system/menu/add',
      method:'post',
      data
  })
}

// 编辑菜单
export function editMenu(data) {
  return request({
      url:'/system/menu/edit',
      method:'post',
      data
  })
}

// 删除菜单
export function deleteMenu(data) {
  return request({
      url:'/system/menu/delete',
      method:'delete',
      data
  })
}

// ------------------------------角色
// 获取角色列表
export function getRoleList(data) {
  return request({
      url:'/system/role/list',
      method:'get',
      params:data
  })
}

// 新增角色
export function addRoleApi(data) {
  return request({
      url:'/system/role/add',
      method:'post',
      data
  })
}
// 编辑角色
export function editRoleApi(data) {
  return request({
      url:'/system/role/edit',
      method:'post',
      data
  })
}
// 获取角色绑定菜单
export function getRolePermission(data) {
  return request({
      url:'/system/role/menu/list',
      method:'get',
      params:data
  })
}

// 修改角色绑定菜单
export function setRolePermission(data) {
  return request({
      url:'/system/role/menu/edit',
      method:'put',
      data
  })
}

// 删除角色
export function deleteRoleApi(data) {
  return request({
      url:'/system/role/delete',
      method:'delete',
      data
  })
}

// ------------------------------用户
// 获取用户列表
export function getuserList(data) {
  return request({
      url:'/system/admin/list',
      method:'get',
      params:data
  })
}

// 新增用户
export function addUserApi(data) {
  return request({
      url:'/system/admin/add',
      method:'post',
      data
  })
}

// 编辑用户
export function editUserApi(data) {
  return request({
      url:'/system/admin/edit',
      method:'post',
      data
  })
}

// 改变用户状态
export function editUserStatus(data) {
  return request({
      url:'/system/admin/modify/enabled',
      method:'post',
      data
  })
}

// 重置用户密码
export function resetUserPsd(data) {
  return request({
      url:'/system/admin/modify/pwd',
      method:'post',
      data
  })
}

// 删除用户
export function deleteUserApi(data) {
  return request({
      url:'/system/admin/del',
      method:'post',
      data
  })
}

// 初次登录修改密码
export function changePsdFirst(data) {
  return request({
      url:'/system/admin/modify/my/init_pwd',
      method:'post',
      data
  })
}
