// 权限指令
/**
 * 接受参数类型 - 字符串-单个权限
 *             - 数组-多个权限 
 * 数组最后一个参数为类型：or-只要一个满足 and-全部都满足
 * 最后一个参数类型不为or或者and，类型默认为or，且会取全部的数组
 * 
 */
import store from "@/store"

export const permission={
  mounted(el,binding) {
    let {value} = binding
    // 拿出所有按钮的code
    let buttonCodes = store.getters.permissionButtons.map(item => item.button_code)
    if(value && typeof(value)=='string'){
      // 字符类型
      if(!buttonCodes.includes(value)){
        // 没有权限，删除dom
        el.parentNode && el.parentNode.removeChild(el)
      }
    }else if(Array.isArray(value)){
      // 数组类型
      /**
       * 权限类型 type
       * or-只要一个满足 and-全部都满足
       */
      let type;
      let hasType=['or','and'].includes(value[value.length-1].toLocaleLowerCase())
      if(hasType){
        //参数中有标明type
        type=value[value.length-1].toLocaleLowerCase()
        // 去掉最后一个权限类型参数
        value.pop()
        // console.log(value,true);
        let operation = type=='or'?'some':'every'
        if(!value[operation](item => buttonCodes.includes(item))){
          // 没有权限，删除dom
          el.parentNode && el.parentNode.removeChild(el)
        }
      }else{
        type='or'
        // console.log(value,false);
        if(!value.some(item => buttonCodes.includes(item))){
          // 没有权限，删除dom
          el.parentNode && el.parentNode.removeChild(el)
        }
      }
    }else{
      throw new Error('permission指令参数类型错误')
    }

  },
}