// el-select标签 滚动指令
import {debounce} from 'lodash/function'

export const optionsLoadMore={
  // 使用该指令，请将绑定的<el-select></el-select>标签的teleported置为false，否则会找不到
  mounted(el,binding) {
    if(!(binding.value instanceof Function)){
      console.error("optionsLoadMore指令的参数必须是回调函数");
      return 
    }
		const SELECT_DOM = el.querySelector('.el-select-dropdown .el-select-dropdown__wrap');
    SELECT_DOM.addEventListener('scroll', debounce(function () {
      const CONDITION = parseInt(this.scrollHeight - this.scrollTop) <= this.clientHeight+10
      if (CONDITION) {
        binding.value()
      }
    },200))
  },
}