import { createApp } from 'vue'
import App from './App.vue'
// 路由
import router from '@/router'
// 状态管理
import store from "@/store"
// 全局样式
import '@/styles/main.scss'
// 路由守卫
import './permission'
// 引入图标库
import * as ElementPlusIconsVue from '@element-plus/icons-vue'

const app = createApp(App)
for (const [key, component] of Object.entries(ElementPlusIconsVue)) {
  app.component(key, component)
}
// 注册全局指令
import * as directives from '@/directives'

Object.keys(directives).forEach(key =>{
  app.directive(key,directives[key])
})
// 分页器
import mPage from "@/components/mPage.vue"

app.component('mPage',mPage)

// svg图标组件
import svgIcon from "@/components/SvgIcon/index.vue";
//引入注册脚本
import 'virtual:svg-icons-register'
app.component('svg-icon', svgIcon)

app.use(router)
app.use(store)
app.mount('#app')
