import router from "./router"
import store from "./store"

import NProgress from "nprogress"
import 'nprogress/nprogress.css'

NProgress.configure({  //进度条设置
  easing:'ease',
  speed:500,
  showSpinner:false
})

const whileList=['/login']

router.beforeEach(async (to,from,next)=>{
  // 进度条开始
  NProgress.start()

  const hasToken = localStorage.getItem('fsms_token')
  // console.log(hasToken);
  if(hasToken){
    // console.log(store.getters.routes.length,store.getters.permissionButtons.length);
    if(to.path=='/login'){
      // 有token的情况下访问login，由于不重定向到主页，所以需要重新设置路由和权限
      if(store.getters.routes.length){
        // 存有之前的路由数组
        location.reload() // 刷新页面，重置路由数组和权限按钮数据
      }else{
        // 没有之前的路由数据，放行
        next()
        NProgress.done()
        return 
      }
    }
    // console.log(to);
    if(store.getters.permissionButtons.length == 0){
      // 获取权限按钮
      await store.dispatch('router/getPermissionButtons') 
    }
    if(store.getters.routes.length && to.name){
      // console.log('放行');
      next()  
      NProgress.done()
    }else{
      // console.log('拦截');
      await store.dispatch('router/setRoutes')
      // 特殊的重定向
      if(to.path == '/redirctPage'){
        if(router.getRoutes().findIndex(item => item.path=='/dashboard/index')!=-1){
          // 有首页的路由权限
          next({path:'/dashboard/index',replace:true})
        }else{
          // 没有首页路由的权限
          next({path:'/financial/list',replace:true})
        }
        return 
      }

      next({...to,replace:true})
    }
  }else{
      if(whileList.indexOf(to.path) !== -1){
          next()
          NProgress.done()
      }else{
          // 不在访问白名单 需要登录
          next('/login')
      }
  }

})