import {createRouter,createWebHistory} from "vue-router"
import Layout from "@/layout/index.vue"

export const routes=[
  {
    path:'/login',
    name:'Login',
    component:() => import("@/views/Login.vue"),
    hidden:true
  },
  {
    path:'/',
    name:'home',
    redirect:'/financial/list',
    hidden:true
  },
  {
    path:'/404',
    name:'404',
    component:()=>import('@/views/404.vue'),
    hidden:true
  },
  {
    path:'/changePassword',
    name:'修改密码',
    component:Layout,
    hidden:true,
    redirect:'/changePassword/index',
    children:[
      {
        path:'index',
        name:'changePassword',
        component:() => import("@/views/ChangePassword.vue"),
        hidden:true,
        meta:{
          title:'修改密码',
          icon_path:''
        }
      }
    ]
  }
]

const router = createRouter({
  history:createWebHistory(),
  routes
})

export default router
