import {createStore} from 'vuex'
import getters from "./getters"

const modulesFiles = import.meta.globEager('./modules/*.js')
// 批量导入文件
const modules = Object.keys(modulesFiles).reduce((modules,modulePath)=>{
  const moduleName = modulePath.replace(/^\.\/(.*)\.\w+$/,'$1').split('/')[1]
  modules[moduleName] = modulesFiles[modulePath].default
  return modules
},{})

const store = createStore({
  modules,
  getters
})

export default store