import {routes} from '../../router'
import router from '../../router'
import {getAsyncRoutes,getPermissionButtons} from '@/api/systemMana'
import Layout from "@/layout/index.vue"

const hiddenArray=[false,true]
// 动态引入views中所有的组件
const routeAllPathToCompMap = import.meta.glob(`@/views/**/*.vue`)

let count=0

const routeHandle=(route,path='index')=>{
  path = path.startsWith('/')?path.substring(1):path
  if(route.component){
    // 一级菜单
    return {
      path,
      name:route.level==0?`${route.path_name}Index`:route.path_name,
      component:routeAllPathToCompMap[`/src/${route.component}.vue`],
      hidden:hiddenArray[route.hidden],
      meta:{
        title:route.name,
        icon_path:route.icon_path
      },
      children:(route.children && route.children.length>0)?route.children.map(item => routeHandle(item,item.path)):[]
    }
  }else{
    if(route.children && route.children.length>0){
      route.children = route.children.map(item=>{
        count++
        return routeHandle(item,item.path)
      })
      return route.children
    }
  }
}

export default {
  state:{
    routes:[],
    permissionButtons:[]
  },
  mutations:{
    SET_ROUTES:(state,routes)=>{
      state.routes = routes
    },
    GET_PERMISSION_BUTTONS:(state,buttons)=>{
      state.permissionButtons = buttons
    }
  },
  actions:{
    // 设置路由
    setRoutes({commit}){
      return new Promise((resolve,reject)=>{
        let asyncRoutes = []
        getAsyncRoutes().then(res=>{
          let routesData = res.data.list || []
          routesData.map(item=>{
            let afterHandlePath = item.path.startsWith('/')?item.path:'/'+item.path
            if(item.hidden_layout==0){
              count=0
              let afterHandle = routeHandle(Object.assign({},item))
              // 判断 afterHandle 是不是数组
              let flag=true
              if(!Array.isArray(afterHandle)){
                flag=false
              }
              asyncRoutes.push({
                path:afterHandlePath,
                name:item.path_name,
                component:Layout,
                hidden:hiddenArray[item.hidden],
                redirect:item.component?`${afterHandlePath}/index`:`${afterHandlePath}/${item.children[0]?item.children[0].path:''}`,
                meta:{
                  title:item.name,
                  icon_path:item.icon_path,
                  type:!flag?'menu':'content',
                  // 是否是一级路由
                  first_level_menu:count===0?true:false
                },
                children:!flag?[afterHandle]:afterHandle
              })
            }else{
              asyncRoutes.push({
                path:afterHandlePath,
                name:item.path_name,
                component:routeAllPathToCompMap[`/src/${item.component}.vue`],
                hidden:hiddenArray[item.hidden],
                meta:{
                  title:item.name,
                  icon_path:item.icon_path,
                  type:'menu'
                }     
              })
            }
          })
          asyncRoutes.push({ path: '/:catchAll(.*)', redirect: '/404',hidden:true})
          asyncRoutes.map(item =>{
            router.addRoute(item)
          })
          commit('SET_ROUTES',[...routes ,...asyncRoutes])
          resolve('设置路由成功')
        })
      })
    },
    // 获取权限按钮
    getPermissionButtons({commit}){
      return new Promise((resolve,reject)=>{
        getPermissionButtons().then(res=>{
          commit('GET_PERMISSION_BUTTONS',res.data.list || [])
          resolve('获取权限按钮成功')
        })
      })
    }
  },
  namespaced:true
}