
export default function serviceCascader() {

  let hasQyBigOne=false
  let hasQyBigTwo=false
  let hasQySmall=false
  let hasFiccSmall=false
  let hasFiccBig=false

  // 套餐选择更改
  // servicesList套餐列表 value-选中的套餐Id cascaderRef - el-cascaser的ref值
  const servicesChange=(servicesList,value,cascaderRef)=>{
    // console.log(servicesList);
    // 权益大套餐/45万
    hasQyBigOne=false
    // 权益大套餐/70万
    hasQyBigTwo=false
    // 11-权益大套餐/45万 12-权益大套餐/70万 单选
    if(value.includes(11) || value.includes(12)){
      value=value.filter(it => ![19,20,21,22,23,24,25,26,27].includes(it))
      if(value.includes(11)){
        value= value.filter(it => it!=12)
        hasQyBigOne=true
      }else if(value.includes(12)){
        hasQyBigTwo=true
      }
    }
    // 行业套餐
    hasQySmall=false
    if(value.some(it => [19,20,21,22,23,24,25,26,27].includes(it))){
      hasQySmall=true
    }

    hasFiccBig=false
    hasFiccSmall=false
    
    if(value.includes(1)){
      // FICC大套餐
      value=value.filter(it => it<90000)
      hasFiccBig=true
    }else if(value.some(it => !(it<90000))){
      // FICC小套餐 - 小套餐的品种ID 都大于 90000
      value=value.filter(it => it!=1)
      hasFiccSmall=true
    }

    let checkedNodes=cascaderRef.getCheckedNodes()

    // 套餐类型
    let hasFICCService = checkedNodes.some(Node => Node.data.product_id == 1)
    let hasQYService = checkedNodes.some(Node => Node.data.product_id == 2)
    // 套餐类型
    let typeValue
    if(hasFICCService&&hasQYService){
      typeValue=3
    }else if(hasFICCService){
      typeValue=1
    }else if(hasQYService){
      typeValue=2
    }else{
      typeValue=0
    }
    // console.log(checkedNodes);
    
    setDisable(servicesList)
    // 返回选中的套餐Id 和套餐类型值
    return {backValue:value,typeValue}
  }
  // 套餐禁用处理
  const setDisable=(List)=>{
    List.forEach(element => {
      if(hasQyBigOne||hasQyBigTwo){
        // 权益大套餐选中了,禁用行业套餐
        if(element.service_template_id==13){
          element.disabled=true
        }
        if(hasQyBigOne){
          // 权益大套餐-45万选中了，禁用70万
          if(element.service_template_id==12){
            element.disabled=true
          }
        }else{
          // 权益大套餐-70万选中了，禁用45万
          if(element.service_template_id==11){
            element.disabled=true
          }
        }
      }else{
        // 权益大套餐没选中
        if([11,12,13].includes(element.service_template_id)){
          element.disabled=false
        }
      }
      // 行业套餐选中了,禁用权益大套餐
      if(hasQySmall){
        if(element.service_template_id==10){
          element.disabled=true
        }
      }else{
        if(element.service_template_id==10){
          element.disabled=false
        }
      }
      // FICC大套餐选中了,禁用FICC小套餐
      if(hasFiccBig){
        if(element.service_template_id==2){
          element.disabled=true
        }
      }else{
        if(element.service_template_id==2){
          element.disabled=false
        }
      }
      // FICC小套餐选中了,禁用FICC大套餐
      if(hasFiccSmall){
        if(element.service_template_id==1){
          element.disabled=true
        }
      }else{
        if(element.service_template_id==1){
          element.disabled=false
        }
      }
      if(element.children){
        setDisable(element.children)
      }
    });
  }

  // 重置套餐禁用状态
  const resetDisable=(List)=>{
    List.forEach(element => {
      element.disabled=false
      if(element.children && element.children.length>0){
        resetDisable(element.children)
      }
    });
  }

  return {
    servicesChange,
    resetDisable
  }
}